//PrOF 2018. Major thanks to YB. Some networking code learned from Lorgan. 
//Thanks for being there, GG2

//Some checks for this are redundant to avoid any networking issue
global.matchStarted = false;

global.rupPacketID = argument1;
global.rupBuffer = buffer_create();

global.playingPlayers = ds_list_create();
global.rupPlayers = ds_map_create();
global.minPlayers = get_integer("Minimum players before allowing game to start:", 2);

object_event_add(PlayerControl, ev_step, ev_step_normal, '
	if (!instance_exists(global.ReadyUpHUD) && !global.matchStarted) instance_create(0, 0, global.ReadyUpHUD);
');


object_event_add(RoomChangeObserver, ev_other, ev_room_start, '
	global.matchStarted = false;
');

global.playerInit = "
    isRupReady = false;
	justJoined = true;
    
    // let the host send readyup data to new players
    if (!global.isHost) exit;
    
    with (Player) {
		if (id == global.myself || !justJoined) exit;
	
		var playerId;
		playerId = ds_list_find_index(global.players, id);
		
		for (i = 0; i <  ds_list_size(global.playingPlayers); i += 1) {
			var getPlayer;
			getPlayer = ds_list_find_value(global.playingPlayers, i);
			if (getPlayer.isRupReady) {
				//Sync player status
				var getPlayerId;
                getPlayerId = ds_list_find_index(global.players, getPlayer);
				write_ubyte(global.rupBuffer, global.ReadyUpHUD.RUP_TOGGLEREADY);
				write_ubyte(global.rupBuffer, getPlayerId);
			}
		}
	}
	//Sync match status
	write_ubyte(global.rupBuffer, global.ReadyUpHUD.RUP_SYNCMATCHSTARTED);
	write_ubyte(global.rupBuffer, global.matchStarted);
	
	//Send data to the new Player
	PluginPacketSendTo(global.rupPacketID, global.rupBuffer, id);
	buffer_clear(global.rupBuffer);
	//show_message('Sent ' + string(playerId));
";
with (Player) execute_string(global.playerInit);
object_event_add(Player, ev_create, 0, global.playerInit);

object_event_add(Player, ev_destroy, 0, '
    ds_list_delete(global.playingPlayers, ds_list_find_index(global.playingPlayers, id));
    ds_map_delete(global.rupPlayers, id);
');

global.ReadyUpHUD = object_add();
object_set_depth(global.ReadyUpHUD, -1000);
object_event_add(global.ReadyUpHUD, ev_create, 0, '

	if (global.matchStarted) instance_destroy();

	//Constants
	RUP_TOGGLEREADY = 1;
	RUP_FORCESTART = 2;
	RUP_SYNCMATCHSTARTED = 3;
	
	aboutToStart = false;
	
	//Pronce to desync, does not matter
	myStatus = false;
	forceStarted = false;
	
	// 0: Playing Player
	// 1: Spectating player
	// 2: Playing Host
	// 3: Spectating host
	drawHelper = 0;
	
	//Used when resetting setup timers and ensure compatibility with different settings
	timerHelper = -1;
	
	rectLinesNumber = 1;
');

object_event_add(global.ReadyUpHUD, ev_step, ev_step_begin, '
	
	if (global.matchStarted) instance_destroy();
	
	if (!global.isHost) {
		if (global.myself.team != TEAM_SPECTATOR) drawHelper = 0;
		else drawHelper = 1;
	}
	else {
		if (global.myself.team != TEAM_SPECTATOR) drawHelper = 2;
		else drawHelper = 3;
	}
	
	//Update playingPlayers list
	for(i = 0; i < ds_list_size(global.players); i += 1){
		player = ds_list_find_value(global.players, i);
				
		if (player.team != TEAM_SPECTATOR && !ds_list_find_value(global.playingPlayers,ds_list_find_index(global.players,player))){
			ds_list_add(global.playingPlayers, player);
		}
		
		if (player.team == TEAM_SPECTATOR){
			//Remove from playingPlayers and rupPlayers
			ds_list_delete(global.playingPlayers, ds_list_find_index(global.playingPlayers, player));
		}
	}
	
    ds_map_clear(global.rupPlayers);
	
	shouldStart	= true;
	
	//Update rupPlayers with new isRupReady value for each player
	for(i = 0; i < ds_list_size(global.playingPlayers); i += 1){
		player = ds_list_find_value(global.playingPlayers, i);
		
		ds_map_add(global.rupPlayers, player, player.isRupReady);
		if(!player.isRupReady) shouldStart = false;
	}
	
	if (forceStarted) {
		shouldStart = true;
	}	
	else if (ds_list_size(global.playingPlayers) < global.minPlayers) {
		shouldStart = false;
	}
		
	if((shouldStart && !aboutToStart)) {
		if (global.isHost) {
            with (NoticeO) {
                instance_destroy();
            }
            notice = instance_create(0, 0, NoticeO);
            notice.notice = NOTICE_CUSTOM;
            notice.message = "The game is about to begin";
        }
		aboutToStart = true;
		alarm[0] = 150 / global.delta_factor;
		//show_message("Game start in 5 sec");
	}
');

object_event_add(global.ReadyUpHUD, ev_step, ev_step_normal, '

	if (global.matchStarted) instance_destroy();
	
	//Before everyone is ready
	//Refill game timers based on game mode.
	//Prevent Intelligences and Generator from being captured/destroyed
	if (instance_exists(CTFHUD)){
		CTFHUD.timer = CTFHUD.timeLimit;
		GameServer.syncTimer = 1;
		global.blueCaps = 0;
		global.redCaps = 0;
	}
	if (instance_exists(ControlPointHUD)){
		if (timerHelper == -1) timerHelper = global.setupTimer;
		global.setupTimer = timerHelper;
		if (ControlPointHUD.mode == 1){
			ControlPointHUD.timer = min(2*30*60,ControlPointHUD.timeLimit);
		}
		else{
			ControlPointHUD.timer = ControlPointHUD.timeLimit;
		}
		GameServer.syncTimer = 1;
	}
	if (instance_exists(KothHUD)){
		KothHUD.cpUnlock = 900;
		GameServer.syncTimer = 1;
	}
	if (instance_exists(DKothHUD)){
		DKothHUD.cpUnlock = 900;
		GameServer.syncTimer = 1;
	}
	if (instance_exists(GeneratorHUD)){
		GeneratorHUD.timer = GeneratorHUD.timeLimit;
		GameServer.syncTimer = 1;
		with (Generator) {
			shieldHp = maxShieldHp;
			hp = maxHp;
		}
	}
	if (instance_exists(ArenaHUD)){
		ArenaHUD.timer = ArenaHUD.timeLimit;
		ArenaHUD.cpUnlock = 45*30;
		GameServer.syncTimer = 1;
	}
	if (instance_exists(TeamDeathmatchHUD)){
		TeamDeathmatchHUD.timer = TeamDeathmatchHUD.timeLimit;
		global.redCaps = 0;
		global.blueCaps = 0;
		GameServer.syncTimer = 1;
	}
	if (instance_exists(InvasionHUD)){
		InvasionHUD.timer = InvasionHUD.timeLimit;
		if (timerHelper == -1) timerHelper = global.setupTimer;
		global.setupTimer = timerHelper;
		GameServer.syncTimer = 1;
	}	
');

object_event_add(global.ReadyUpHUD, ev_step, ev_step_end, '

	if (!aboutToStart && !PlayerControl.menuOpen) {
		if (keyboard_check_pressed(global.drop)) {
			event_user(1);
		}
		else if (keyboard_check_pressed(vk_f4)) {
			event_user(2);
		}
	}
	
	event_user(0);
	event_user(3);
');

object_event_add(global.ReadyUpHUD, ev_draw, 0, '
	xoffset = view_xview[0];
	yoffset = view_yview[0];
	xsize = view_wview[0];
	ysize = view_hview[0];
	orangeTitle = make_color_rgb(255,102,000);
	rectHeightAddition = (1+ds_list_size(global.playingPlayers)*11)+44; //1+number of names, line takes up 11px; 33 is for the titles
	readyNameDisplay = "";
	unreadyNameDisplay = "";

	draw_set_halign(fa_left);
	draw_set_valign(fa_top);

	//rectangle
	draw_set_color(c_black);
	draw_set_alpha(0.6);
	rectX1 = xoffset+95;
	rectY1 = yoffset+245;
	rectX2 = xoffset+95+(20*9);
	rectY2 = yoffset+245+rectHeightAddition;
	draw_rectangle(rectX1,rectY1,rectX2,rectY2,false);

	//lines
	draw_set_color(c_white);
	draw_line(rectX1,rectY1,rectX1,rectY2); //left side, downwards
	draw_line(rectX1+1,rectY1,rectX2,rectY1); //top side, right
	draw_line(rectX2,rectY1,rectX2,rectY2); //right side, downwards
	draw_line(rectX1,rectY2,rectX2+1,rectY2); //bottom side, right
	draw_set_color(c_black);

	//text
	draw_set_alpha(1);

	//READY PLAYERS
	for(i = 0; i < ds_list_size(global.playingPlayers); i += 1){
		player = ds_list_find_value(global.playingPlayers, i);
		if (ds_map_find_value(global.rupPlayers, player) == true){
			if (player != -1){
				readyNameDisplay += string(player.name)+"#";
			}
		}
	}

	//READY title
	draw_set_color(orangeTitle);
	readyPlayersNumber = string_count("#",readyNameDisplay);
	draw_text(xoffset+100,yoffset+250,"---Ready("+string(readyPlayersNumber)+"/"+string(ds_list_size(global.playingPlayers))+")#");

	//READY player list
	draw_set_color(c_white);
	draw_text(xoffset+100,yoffset+250,"#"+readyNameDisplay);


	textHeightAddition1 = ((1+string_count("#",readyNameDisplay))*11)+11;


	//UNREADY PLAYERS
	for(i = 0; i < ds_list_size(global.playingPlayers); i += 1){
		player = ds_list_find_value(global.playingPlayers, i);
		if (ds_map_find_value(global.rupPlayers, player) == false){
			if (instance_exists(player)){
				if (player != -1){
					unreadyNameDisplay += string(player.name)+"#";
					if (keyboard_check(vk_enter)) show_message(string(player.isRupReady));
				}
			}
		}
	}

	//UNREADY title
	draw_set_color(orangeTitle);
	unreadyPlayersNumber = string_count("#",unreadyNameDisplay);
	draw_text(xoffset+100,yoffset+250+textHeightAddition1,"---Unready("+string(unreadyPlayersNumber)+"/"+string(ds_list_size(global.playingPlayers))+")#");

	//UNREADY player list
	draw_set_color(c_white);
	draw_text(xoffset+100,yoffset+250+textHeightAddition1,"#"+unreadyNameDisplay);

	if (drawHelper == 1) exit;
	
	//extra information
	draw_set_halign(fa_center);
	draw_set_valign(fa_top);

	//Instructions background
	draw_set_color(c_black);
	draw_set_alpha(0.6);
	infoX1 = xoffset+xsize/2-175;
	infoY1 = yoffset+ysize/2+50;
	infoX2 = xoffset+xsize/2+177;
	
	if (drawHelper == 2) infoY2 = yoffset+ysize/2+75+(rectLinesNumber*11);
	else infoY2 = yoffset+ysize/2+60+(rectLinesNumber*11);
	
	draw_rectangle(infoX1, infoY1, infoX2, infoY2, false);

	//Instructions background border
	draw_set_color(c_white);
	draw_line(infoX1, infoY1, infoX1, infoY2); //left side, downwards
	draw_line(infoX1+1, infoY1, infoX2, infoY1); //top side, right
	draw_line(infoX2, infoY1, infoX2, infoY2); //right side, downwards
	draw_line(infoX1, infoY2, infoX2+1, infoY2); //bottom side, right
	draw_set_color(c_black);

	//text
	draw_set_color(c_white);
	draw_set_alpha(1);

	//Instructions text
	switch (drawHelper) {
		case 0:
			draw_text_transformed(xoffset+xsize/2, yoffset+ysize/2+55, "Press " + chr(global.drop) + " to ready/unready", 1, 1, 0);
			break;
		case 2:
			draw_text_transformed(xoffset+xsize/2, yoffset+ysize/2+55, "Press " + chr(global.drop) + " to ready/unready", 1, 1, 0);
			draw_text_transformed(xoffset+xsize/2, yoffset+ysize/2+70, "Press the F4 key to force game start", 1, 1, 0);
			break;
		case 3:
			draw_text_transformed(xoffset+xsize/2, yoffset+ysize/2+55, "Press the F4 key to force game start", 1, 1, 0);
			break;
	}
	
	/*
	if instance_exists(ArenaHUD){ //ARENA ROUNDS
		rectLinesNumber = 2;
		draw_text_transformed(xoffset+xsize/2, yoffset+ysize/2+50+5+11, "Rounds needed to win: " + string(global.arenaRoundsToWin), 1, 1, 0);
	}else{
		rectLinesNumber = 1;
	}
	*/
');

object_event_add(global.ReadyUpHUD, ev_other, ev_user0, '
	//Receive messages as host
	if (!global.isHost) exit;
	
    while(PluginPacketGetBuffer(global.rupPacketID) != -1) {
        rupReceiveBuffer = PluginPacketGetBuffer(global.rupPacketID);
        switch(read_ubyte(rupReceiveBuffer)) {
            case RUP_TOGGLEREADY:
                player = PluginPacketGetPlayer(global.rupPacketID);
                player.isRupReady = !player.isRupReady;

                // Dispatch status change
                var playerId;
                playerId = ds_list_find_index(global.players, player);
                write_ubyte(global.rupBuffer, RUP_TOGGLEREADY);
                write_ubyte(global.rupBuffer, playerId);
                with(Player) {
                    if (id != global.myself) {
                        PluginPacketSendTo(global.rupPacketID, global.rupBuffer, id);
                    }
                }
                buffer_clear(global.rupBuffer);
            break;
            case RUP_FORCESTART:
                // are clients even allowed to send that?
				//No they are not, right.
            break;
			case RUP_SYNCMATCHSTARTED:
                player = PluginPacketGetPlayer(global.rupPacketID);

                //Reply with global.matchStarted
                var playerId;
                playerId = ds_list_find_index(global.players, player);
                write_ubyte(global.rupBuffer, RUP_SYNCMATCHSTARTED);
                write_ubyte(global.rupBuffer, global.matchStarted);
                with(Player) {
                    if (id != global.myself) {
                        PluginPacketSendTo(global.rupPacketID, global.rupBuffer, id);
                    }
                }
                buffer_clear(global.rupBuffer);
            break;
        }

        buffer_clear(rupReceiveBuffer);
        PluginPacketPop(global.rupPacketID);
    }
	
');

object_event_add(global.ReadyUpHUD, ev_other, ev_user1, '
	
	//Send status change
	if (global.isHost) {
		write_ubyte(global.rupBuffer, RUP_TOGGLEREADY);
		write_ubyte(global.rupBuffer, 0);
		with(Player) {
            if (id != global.myself) {
                PluginPacketSendTo(global.rupPacketID, global.rupBuffer, id);
            }
		}
		buffer_clear(global.rupBuffer);
		
		myStatus = global.myself.isRupReady;
        write_ubyte(global.serverSocket, CHAT_BUBBLE);
        write_ubyte(global.serverSocket, myStatus + 43);
	}
	else if (global.myself.team != TEAM_SPECTATOR) {		
		write_ubyte(global.rupBuffer, RUP_TOGGLEREADY);
		PluginPacketSend(global.rupPacketID, global.rupBuffer);
		buffer_clear(global.rupBuffer);
		
		myStatus = global.myself.isRupReady;
        write_ubyte(global.serverSocket, CHAT_BUBBLE);
        write_ubyte(global.serverSocket, myStatus + 43);
	}
        
    // actually do it as host
	if (global.isHost) {
        global.myself.isRupReady = !global.myself.isRupReady;
    }
');

object_event_add(global.ReadyUpHUD, ev_other, ev_user2, '
	//Force game to start, as host
	if (!global.isHost) exit;
	
	write_ubyte(global.rupBuffer, RUP_FORCESTART);
	with(Player) {
        if (id != global.myself) {
            PluginPacketSendTo(global.rupPacketID, global.rupBuffer, id);
        }
	}
	buffer_clear(global.rupBuffer);

	for (i = 0; i < ds_list_size(global.playingPlayers); i += 1) {
		player = ds_list_find_value(global.playingPlayers, i);
		player.isRupReady = true;
	}
	
	forceStarted = true;
');

object_event_add(global.ReadyUpHUD, ev_other, ev_user3, '
	//Read status changes as client
	if (global.isHost) exit;
	
	while(PluginPacketGetBuffer(global.rupPacketID) != -1) {
        rupReceiveBuffer = PluginPacketGetBuffer(global.rupPacketID);
        switch(read_ubyte(rupReceiveBuffer)) {
            case RUP_TOGGLEREADY:
                var playerId, player;
                playerId = read_ubyte(rupReceiveBuffer);
                player = ds_list_find_value(global.playingPlayers, playerId);
                player.isRupReady = !player.isRupReady;				
			break;
			
            case RUP_FORCESTART:
                with (Player) {
					isRupReady = true;
				}
				forceStarted = true;
			break;
			
			case RUP_SYNCMATCHSTARTED:
				global.matchStarted = read_ubyte(rupReceiveBuffer);
				global.myself.justJoined = false;
			break;
        }

        buffer_clear(rupReceiveBuffer);
        PluginPacketPop(global.rupPacketID);
    }
');

object_event_add(global.ReadyUpHUD, ev_other, ev_user4, '
	
	//Sync global.matchStarted
	if (global.isHost) exit;
	
	write_ubyte(global.rupBuffer, RUP_SYNCMATCHSTARTED);
	PluginPacketSend(global.rupPacketID, global.rupBuffer);
	buffer_clear(global.rupBuffer);

');

/*
object_event_add(Character, ev_draw, 0, '
    draw_text(x, y - 20, string(player.isRupReady));
');
*/

object_event_add(global.ReadyUpHUD, ev_alarm, 0, '

	//reset character things
	with (Character){
		x = xstart;
		y = ystart;
		hp = maxHp;
		ubered = 0;
		hspeed = 0;
		vspeed = 0;
		speed = 0;
		moveStatus = 0;
		//also need to reset stats
	}
	with (Medigun){
		ubering = false;
		uberCharge = 0;
		uberReady = false;
	}

	//refill game timers based on game mode.
	if (instance_exists(CTFHUD)){
		CTFHUD.timer = CTFHUD.timeLimit;
		GameServer.syncTimer = 1;
		
	}
	if (instance_exists(ControlPointHUD)){
		if (ControlPointHUD.mode) == 1{
			ControlPointHUD.timer = max(7*30*60, ControlPointHUD.timeLimit);
		}
		else {
			ControlPointHUD.timer = ControlPointHUD.timeLimit;
		}
		//ControlPointHUD.timer=ControlPointHUD.timeLimit
		GameServer.syncTimer = 1;
	}
	if (instance_exists(KothHUD)){
		KothHUD.cpUnlock = 900;
		GameServer.syncTimer = 1;
	}
	if (instance_exists(DKothHUD)){
		DKothHUD.cpUnlock = 900;
		GameServer.syncTimer = 1;
	}
	if (instance_exists(GeneratorHUD)){
		GeneratorHUD.timer = GeneratorHUD.timeLimit;
		GameServer.syncTimer = 1;
	}
	if (instance_exists(ArenaHUD)){
		ArenaHUD.timer = ArenaHUD.timeLimit;
		ArenaHUD.cpUnlock = 45*30;
		GameServer.syncTimer = 1;
		serverArenaRestart();
	}
	if (instance_exists(TeamDeathmatchHUD)){
		TeamDeathmatchHUD.timer = TeamDeathmatchHUD.timeLimit;
		global.redCaps = 0;
		global.blueCaps = 0;
		GameServer.syncTimer = 1;
	}
	if (instance_exists(InvasionHUD)){
		InvasionHUD.timer = InvasionHUD.timeLimit;
		GameServer.syncTimer = 1;
	}
	
	global.matchStarted = true;
	
	with (Player) {
		isRupReady = false;
		justJoined = true;
	}
	
	instance_destroy();
');